Imports System.Data.SqlClient
Imports System.Reflection


Public Class cNCTSRouten
    Property nctsr_id As Integer
    Property nctsr_von As Object = Nothing
    Property nctsr_von_region As Object = Nothing
    Property nctsr_nach As Object = Nothing
    Property nctsr_dauer_in_tagen As Integer
    Property nctsr_route As Object = Nothing
    Property nctsr_transportmittel As Object = Nothing

    Public hasEntry = False

    Dim SQL As New SQL

    Sub New(nctsr_id)
        Me.nctsr_id = nctsr_id
        LOAD()
    End Sub

    Sub New()

    End Sub
    Function getParameterList() As List(Of VERAG_PROG_ALLGEMEIN.SQLVariable)
        Dim list As New List(Of VERAG_PROG_ALLGEMEIN.SQLVariable)
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("nctsr_id", nctsr_id,, True))
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("nctsr_von", nctsr_von))
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("nctsr_von_region", nctsr_von_region))
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("nctsr_nach", nctsr_nach))
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("nctsr_dauer_in_tagen", nctsr_dauer_in_tagen))
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("nctsr_route", nctsr_route))
        list.Add(New VERAG_PROG_ALLGEMEIN.SQLVariable("nctsr_transportmittel", nctsr_transportmittel))


        Return list
    End Function



    Public Function SAVE() As Boolean
        Dim list As List(Of VERAG_PROG_ALLGEMEIN.SQLVariable) = getParameterList()

        Dim sqlstr = " BEGIN TRAN IF EXISTS(SELECT * FROM tblNTCSRouten  WHERE nctsr_id=@nctsr_id) " &
                       " BEGIN " & getUpdateCmd() & " END " &
                       " Else " &
                       " BEGIN " & getInsertCmd() & " END " &
                       " commit tran "

        Return SQL.doSQLVarList(sqlstr, "FMZOLL", , list)
    End Function

    Public Sub LOAD()
        Try
            hasEntry = False
            Using conn As SqlConnection = SQL.GetNewOpenConnectionFMZOLL()
                Using cmd As New SqlCommand("SELECT * FROM tblNTCSRouten WHERE nctsr_id=@nctsr_id  ", conn)
                    cmd.Parameters.AddWithValue("@nctsr_id", nctsr_id)
                    Dim dr = cmd.ExecuteReader()
                    If dr.Read Then
                        For Each li In getParameterList()
                            Dim propInfo As PropertyInfo = Me.GetType.GetProperty(li.Scalarvariable)

                            If dr.Item(li.Text) Is DBNull.Value Then
                                propInfo.SetValue(Me, Nothing)
                            Else
                                propInfo.SetValue(Me, dr.Item(li.Text))
                            End If

                        Next
                        hasEntry = True
                    End If
                    dr.Close()
                End Using
            End Using
        Catch ex As Exception
            MsgBox("Fehler in der Funktion '" & System.Reflection.MethodInfo.GetCurrentMethod.Name & "'" & vbNewLine & vbNewLine & ex.Message & vbNewLine & vbNewLine & ex.StackTrace)
        End Try
    End Sub



    Public Function getUpdateCmd() As String
        Try
            Dim list As List(Of VERAG_PROG_ALLGEMEIN.SQLVariable) = getParameterList()

            Dim str As String = ""
            For Each i In list
                If Not i.isPrimaryParam Then
                    str &= "[" & i.Text & "] = @" & i.Scalarvariable & "," '.Replace("-", "").Replace(" ", "") & ","
                End If
            Next
            str = str.Substring(0, str.Length - 1) 'wg. ','
            Return (" UPDATE [tblNTCSRouten] SET " & str & " WHERE nctsr_id=@nctsr_id ")

        Catch ex As Exception
            MsgBox("Fehler in der Funktion '" & System.Reflection.MethodInfo.GetCurrentMethod.Name & "'" & vbNewLine & vbNewLine & ex.Message & vbNewLine & vbNewLine & ex.StackTrace)
        End Try
        Return ""
    End Function


    Public Function getInsertCmd() As String
        Try
            Dim list As List(Of VERAG_PROG_ALLGEMEIN.SQLVariable) = getParameterList()
            Dim str As String = ""
            Dim values As String = ""
            For Each i In list
                If Not i.isPrimaryParam Then
                    str &= "[" & i.Text & "],"
                    values &= "@" & i.Scalarvariable & "," '.Replace("-", "").Replace(" ", "") & ","
                End If
            Next
            str = str.Substring(0, str.Length - 1) 'wg. ','
            values = values.Substring(0, values.Length - 1) 'wg. ','
            Return (" INSERT INTO tblNTCSRouten  (" & str & ") VALUES(" & values & ")  ")
        Catch ex As Exception
            MsgBox("Fehler in der Funktion '" & System.Reflection.MethodInfo.GetCurrentMethod.Name & "'" & vbNewLine & vbNewLine & ex.Message & vbNewLine & vbNewLine & ex.StackTrace)
        End Try
        Return ""
    End Function

End Class


